/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"time"

	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	scheme "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated_ambassador/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// TLSContextsGetter has a method to return a TLSContextInterface.
// A group's client should implement this interface.
type TLSContextsGetter interface {
	TLSContexts(namespace string) TLSContextInterface
}

// TLSContextInterface has methods to work with TLSContext resources.
type TLSContextInterface interface {
	Create(*v1.TLSContext) (*v1.TLSContext, error)
	Update(*v1.TLSContext) (*v1.TLSContext, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.TLSContext, error)
	List(opts metav1.ListOptions) (*v1.TLSContextList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.TLSContext, err error)
	TLSContextExpansion
}

// tLSContexts implements TLSContextInterface
type tLSContexts struct {
	client rest.Interface
	ns     string
}

// newTLSContexts returns a TLSContexts
func newTLSContexts(c *GetambassadorV1Client, namespace string) *tLSContexts {
	return &tLSContexts{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the tLSContext, and returns the corresponding tLSContext object, and an error if there is any.
func (c *tLSContexts) Get(name string, options metav1.GetOptions) (result *v1.TLSContext, err error) {
	result = &v1.TLSContext{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tlscontexts").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of TLSContexts that match those selectors.
func (c *tLSContexts) List(opts metav1.ListOptions) (result *v1.TLSContextList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.TLSContextList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tlscontexts").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested tLSContexts.
func (c *tLSContexts) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("tlscontexts").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a tLSContext and creates it.  Returns the server's representation of the tLSContext, and an error, if there is any.
func (c *tLSContexts) Create(tLSContext *v1.TLSContext) (result *v1.TLSContext, err error) {
	result = &v1.TLSContext{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("tlscontexts").
		Body(tLSContext).
		Do().
		Into(result)
	return
}

// Update takes the representation of a tLSContext and updates it. Returns the server's representation of the tLSContext, and an error, if there is any.
func (c *tLSContexts) Update(tLSContext *v1.TLSContext) (result *v1.TLSContext, err error) {
	result = &v1.TLSContext{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("tlscontexts").
		Name(tLSContext.Name).
		Body(tLSContext).
		Do().
		Into(result)
	return
}

// Delete takes name of the tLSContext and deletes it. Returns an error if one occurs.
func (c *tLSContexts) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tlscontexts").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *tLSContexts) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tlscontexts").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched tLSContext.
func (c *tLSContexts) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.TLSContext, err error) {
	result = &v1.TLSContext{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("tlscontexts").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
